package com.lambelly.lambnes.context;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.GenericXmlApplicationContext;

public class ApplicationContextManager
{
	private static ApplicationContextManager applicationContextManager;
	private ApplicationContext applicationContext;
	
	private ApplicationContextManager(ApplicationContext applicationContext)
	{
		this.applicationContext = applicationContext;
	}
	
	public static ApplicationContextManager getInstance()
	{
		if (applicationContextManager == null)
		{
			ApplicationContext applicationContext = new GenericXmlApplicationContext("applicationContext.xml");
			applicationContextManager = new ApplicationContextManager(applicationContext);
		}
		
		return applicationContextManager;
	}
	
	@SuppressWarnings("unchecked")
	public <T> T getBean(String beanId)
	{
		return (T)applicationContext.getBean(beanId);
	}
}
