package com.lambelly.lambnes.platform.ppu;

import org.apache.log4j.Logger;

import com.lambelly.lambnes.LambNes;
import com.lambelly.lambnes.platform.NesMasterPalette;
import com.lambelly.lambnes.platform.Platform;
import com.lambelly.lambnes.platform.MasterColor;

public class PaletteColor
{
	private int paletteIndex = 0;
	private int masterPaletteIndex = 0;
	
	private Logger logger = Logger.getLogger(PaletteColor.class);
	
	public PaletteColor(int paletteIndex, int masterPaletteIndex)
	{		
		this.setPaletteIndex(paletteIndex);
		this.setMasterPaletteIndex(masterPaletteIndex);
		
		//logger.info("instantiated with MPI from " + address + " : " + this.toString());
	}
	
	public String toString()
	{
		return "MPI: " + this.getMasterPaletteIndex();
	}
	
	public MasterColor getMasterPaletteColor()
	{
		return NesMasterPalette.getInstance().getColor(masterPaletteIndex);
	}

	public int getMasterPaletteIndex()
	{
		return masterPaletteIndex;
	}

	public void setMasterPaletteIndex(int masterPaletteIndex)
	{
		this.masterPaletteIndex = masterPaletteIndex;
	}

	public int getPaletteIndex()
    {
    	return paletteIndex;
    }

	public void setPaletteIndex(int paletteIndex)
    {
    	this.paletteIndex = paletteIndex;
    }
}
