package com.lambelly.lambnes.util;
import org.apache.log4j.Logger;
import java.io.InputStreamReader;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.File;
import java.io.FileWriter;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.charset.Charset;
import java.lang.StringBuilder;
import java.util.StringTokenizer;

public class SavRamIOUtil
{
	private static Logger logger = Logger.getLogger(SavRamIOUtil.class);
	
	public static boolean savRamExists(String romName)
	{
		File f = new File("./save", romName);
		return f.exists();
	}
	
	public static int[] readSavRam(String romName) throws FileNotFoundException, IOException
	{
		int ram[] = null;
		
		// open file
		Charset utf8 = Charset.forName("UTF-8");     
		File f = new File("./save", romName);
		BufferedReader input = new BufferedReader(                            
				new InputStreamReader(                                
						new FileInputStream(f),utf8)); 
		
		// parse file to int array
		String inStr = null;
		inStr = input.readLine();
		StringTokenizer st = new StringTokenizer(inStr);
		
		int tokenCount = st.countTokens();
		ram = new int[tokenCount];
		for(int j=0; j < tokenCount; j++)
		{
			String token = st.nextToken();
			ram[j] = Integer.parseInt(token);
		}
		
		input.close();
			
		return ram;
	}
	
	public static void writeSavRam(int[] ram, String romName) throws FileNotFoundException, IOException
	{
		// parse array to string
		StringBuilder sb = new StringBuilder();
		for (int entry : ram)
		{
			sb.append(entry + " ");
		}
		
		logger.debug(sb.toString());
		
		File f = new File("./save", romName);
		BufferedWriter output = new BufferedWriter(                            
				new FileWriter(f));
                                
		output.write(sb.toString());
		output.close();
	}	
}
